/*
Tools.js
version 1.11
By Satis
2 June 2010
http://clankiller.com/programs/javascript/tools.php
*/
function tools(){}
tools.getMouse = function(e){
	var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX;
		posy = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	return [posx, posy];
}
tools.getSize = function(item){
	var results = new Array();
	results['height'] = item.offsetHeight;
	results['width'] = item.offsetWidth;
	results['top'] = parseInt(item.style.top.substring(0, item.style.top.length - 2));
	results['left'] = parseInt(item.style.left.substring(0, item.style.left.length - 2));
	if(results['top'] = 'NaN' || results['left'] == 'NaN'){
		var t = tools.getLocation(item);
		results['top'] = t['top'];
		results['left'] = t['left'];
	}
	return results;
}
tools.getViewport = function(){
	var tArray = new Array();
	tArray['height'] = window.innerHeight || document.documentElement.clientHeight || document.getElementsByTagName('body')[0].clientHeight;
	tArray['width'] = window.innerWidth || document.documentElement.clientWidth || document.getElementsByTagName('body')[0].clientWidth;
	return tArray;
}
tools.getPageSize = function(){
	var t = new Array();
	if (document.documentElement.clientHeight && document.documentElement.clientWidth) {// Firefox
		t['height'] = document.documentElement.clientHeight;
		t['width'] = document.documentElement.clientWidth;
	} 
	else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
		t['height'] = document.body.scrollHeight;
		t['width'] = document.body.scrollWidth;
	} 
	else { // works in Explorer 6 Strict, Mozilla (not FF) and Safari
		t['height'] = document.body.offsetHeight;
		t['width'] = document.body.offsetWidth;
	}
	return t;
}
tools.getLocation = function(el){
	var results = new Array();
	results['left'] = 0; results['top'] = 0;
	while(el != null){
		results['left'] += el.offsetLeft;
		results['top'] += el.offsetTop;
		el = el.offsetParent;
	}
	return results;
}
tools.getBaseName = function(name){
	return name.substr(name.lastIndexOf('/') + 1);
}
tools.isInt = function(i){
	return (i % 1) == 0;
}
tools.urlEncode = function(str) {
	return escape(str).replace(/\+/g,'%2B').replace(/%20/g, '+').replace(/\*/g, '%2A').replace(/\//g, '%2F').replace(/@/g, '%40');
}
tools.urlDecode = function(str) {
	return unescape(str).replace(/\+/g,' ').replace(/%2B/g, '+').replace(/%2A/g, '*').replace(/%2F/g, '/').replace(/%40/g, '@');
}
tools.trim = function(str){
	str = str.replace(/^\s+/, '');
	for (var i = str.length - 1; i >= 0; i--) {
		if (/\S/.test(str.charAt(i))) {
			str = str.substring(0, i + 1);
			break;
		}
	}
	return str;
}
tools.countLines = function(strtocount, cols) {
	var hard_lines = 1;
	var last = 0;
	while ( true ) {
		last = strtocount.indexOf("\n", last+1);
		hard_lines++;
		if ( last == -1 ) break;
	}
	var soft_lines = Math.round(strtocount.length / (cols-1));
	if(hard_lines > soft_lines)
		soft_lines = hard_lines;
	return soft_lines;
}
tools.resizeTextarea = function(el){
	var t = tools.countLines(el.value, el.cols+1);
	el.rows = t;
}
tools.resizeTextInput = function(el, minsize){
	if(minsize == null)
		minsize = 5;
	el.size = (el.value.length < minsize)? minsize : el.value.length;
}
tools.getSelectValue = function(el){
	return el.options[el.selectedIndex].value;
}
tools.colorRows = function(el, overwrite){
	while(el && el.tagName != 'TABLE')
		el = el.parentNode;
	if(!el)	return
	
	var rows = new Array();
	for(var i=0; i<el.childNodes.length; i++){
		if(el.childNodes[i] && el.childNodes[i].tagName == 'TBODY'){
			var t = el.childNodes[i].childNodes;
			for(var j=0; j<t.length; j++){
				if(t[j].tagName == 'TR')
					rows[rows.length] = t[j];
			}
		}
	}
	
	for(var i=0; i<rows.length; i++){
		//don't lose specifically defined classes
		if(overwrite || rows[i].className == '' || rows[i].className == 'even' || rows[i].className == 'odd')
			alert(i);
			rows[i].className = (i % 2 == 0)? 'even' : 'odd';
	}	
}
tools.getClassSelector = function(stylesheet, selector){
	var css = (document.styleSheets[stylesheet].cssRules)? document.styleSheets[0].cssRules : document.styleSheets[0].rules;
	for(var i=0; i<css.length; i++){
		if(css[i].selectorText == selector)
			return css[i].style;
	}
	/*
CSSStyleRule : CSSRule
http://www.navioo.com/DOMReference/HTML/reference/api/cssstylerule.php
	Inherited Properties
		cssText : String
			Text for the current CSS rule.
		parentRule : CSSRule
			Parent rule for the current CSS rule.
		parentStyleSheet : CSSStyleSheet
			CSS style sheet that contains the rule.
		type : Number
			Type of CSS rule.
	Properties
		selectorText : String
			Specifies the name of the CSS selector that the rule applies to.
		style : CSSStyleDeclaration
			Style values for the CSS selector.
	
CSSStyleDeclaration: Object
http://www.navioo.com/DOMReference/html/reference/api/cssstyledeclaration.php
	Properties
		cssText : String
			Text for the current CSS rule.
		length : Number
			Number of CSS style attributes in the style declaration block.
	Functions
		static getPropertyCSSValue(String propertyName) : CSSValue
			Returns a CSS attribute value as an object.
			Parameters
				String 	propertyName 	Name of the CSS attribute to return the CSS value for.
		static getPropertyPriority(String propertyName) : String
			Returns the priority of a CSS attribute.
			Parameters
				String 	propertyName 	Name of the CSS attribute to return the priority value for.
		static getPropertyValue(String propertyName) : String
			Returns a CSS attribute value as a string.
			Parameters
				String 	propertyName 	Name of the CSS attribute to return the value for.
		static item(Number index) : String
			Returns the name of the CSS attribute at the specified position.
			Parameters
				Number 	index 	Position of the CSS attribute to retrieve.
		static removeProperty(String propertyName) : String
			Removes the specified CSS attribute from the CSS style declaration block.
			Parameters
				String 	propertyName 	Name of the CSS attribute to delete.
		setProperty(String propertyName, String value, String priority) : void
			Sets the value for a CSS attribute for a CSS style declaration block.	
	*/
}
tools.deselect = function(){
	if(document.selection && document.selection.empty) {
		document.selection.empty();
    } 
	else if(window.getSelection) {
        var sel = window.getSelection();
        sel.removeAllRanges();
    }
}